###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$boardindexplver = "1 Gold - SP 1.3";

$high_lst = 5; # Set the number of members in the Top-Poster list

sub BoardIndex {
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);

			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
	$yymain .= qq~
<P align="left"><font size="2" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>~;
	
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$yymain .= qq~<BR>$txt{'850'}<a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>$txt{'851'}~;	
}

open(FILE,"$vardir/usertoday.txt");
@utoday=<FILE>;
close(FILE);

$usertodaycount = @utoday;
$usertoday = '';
for($a=1;$a < $usertodaycount;$a++)
{
	$utoday[$a] =~ s/\n//gi;
	$name = $utoday[$a];
	if($useraccount{$name} eq ''){&LoadUser($name);}
	$usertoday .= qq~<a href="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a>, ~;
	if($name eq $username){$Inserted = 'true';}
}
$usertodaycount = $usertodaycount-1;

if($utoday[0] != $mday)
{
	open(FILE,">$vardir/usertoday.txt");
	print FILE "$mday\n";
	if($username ne 'Guest')
	{
		print FILE "$username\n";
	}
	fclose(FILE);
}
elsif($username ne 'Guest' && $Inserted ne 'true')
{
	open(FILE,">>$vardir/usertoday.txt");
	print FILE "$username\n";
	fclose(FILE);
}
	if($shownewsfader == 1) {
		if(!$fadedelay) { $fadedelay = 5000; }
		$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'102'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" align="center" height="60">
<script language="JavaScript1.2" type="text/javascript">
<!--
var delay = $fadertime
var bcolor = "$color{'windowbg2'}"
var tcolor = "$color{'fadertext'}"
var fcontent = new Array()
begintag = '<font size="2"><B>'
~;
fopen(FILE, "$vardir/news.txt");
@newsmessages = <FILE>;
fclose(FILE);
for($i=0; $i < @newsmessages; $i++) {
	$newsmessages[$i] =~ s/\n|\r//g;
	if($i != 0){ $yymain .= qq~\n~; }
	$message = $newsmessages[$i];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	$message =~ s/\"/\\\"/g;
	$yymain .= qq~fcontent[$i] = "$message"~;
}
$yymain .= qq~
closetag = '</b></font>'
// -->
</script>
<script language="JavaScript1.2" type="text/javascript" src="$faderpath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
if (navigator.appVersion.substring(0,1) < 5 && navigator.appName == "Netscape") {
   var fwidth = screen.availWidth / 2;
   var bwidth = screen.availWidth / 4;
   document.write('<ilayer id="fscrollerns" width='+fwidth+' height=35 left='+bwidth+' top=0><layer id="fscrollerns_sub" width='+fwidth+' height=35 left=0 top=0></layer></ilayer>');
   window.onload = fade;
}
else if (navigator.userAgent.search(/Opera/) != -1 || (navigator.platform != "Win32" && navigator.userAgent.indexOf('Gecko') == -1)) {
   document.open();
   document.write('<div id="fscroller" style="width:90%; height:15px; padding:2px">');
   for(i=0; i < fcontent.length; ++i) {
      document.write(begintag+fcontent[i]+closetag+'<br>');
   }
   document.write('</div>');
   document.close();
   window.onload = fade;
}
else {
   document.write('<div id="fscroller" style="width:90% height:15px; padding:2px"></div>');
   window.onload = fade;
}
// -->
</script>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}
########showcase poll start
# Look for a showcase.poll file.
if (-e "$datadir/showcase.poll") {
	my ($board, $viewnum);
	fopen (FILE, "$datadir/showcase.poll");
	@showdata = <FILE>;
	fclose (FILE);
	$showcasepoll = $showdata[0];
	$showcasepoll =~ s~\n~~g;
	($scboard, $viewnum) = split(/\|/, $showcasepoll);

	# Look for a valid poll file.
	if (-e "$datadir/$viewnum.poll") {
	$pollthread = 1;
	unless( &BoardAccessGet($scboard) ) { $pollthread = 0; }
	}
	if ($pollthread) { 
		$yymain .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
		require "$sourcedir/Poll.pl"; &display_poll($viewnum, 1, $scboard);
	 }
}
#########showcase poll end

	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
      </tr>~;

	foreach $curcat (@categories) {
		unless( $openmemgr{$curcat} ) { next; }
		$yymain .= qq~<tr>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> <font size=2><b>$catname{$curcat}</b></font></a></td>
      </tr>~;
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			$curboarddescr = <FILE>;
			chomp $curboarddescr;
			$curboardmods = <FILE>;
			chomp $curboardmods;
			fclose(FILE);
			%moderators = ();
			foreach $curuser (split(/\|/, $curboardmods)) {
				&LoadUser($curuser);
				$moderators{$curuser} = $userprofile{$curuser}->[1];

			}
			$showmods = '';
			if(scalar keys %moderators == 1) { $showmods = qq~$txt{'298'}: ~; }
			elsif(scalar keys %moderators != 0) { $showmods = qq~$txt{'299'}: ~; }
			while($tmpa = each(%moderators)) {
				&FormatUserName($tmpa);
				$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
			}
			$showmods =~ s/, \Z//;
			if($showmods eq "") { $showmods = qq~$txt{'298'}: $txt{'470'}~; }
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$lastposter = $lastposter{$curboard};
			unless( $lastposterguest{$curboard} || $lastposter{$curboard} eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			$lastposter ||= $txt{'470'};
			$lastposttime ||= $txt{'470'};
			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%">
        <font size="2"><a name="$curboard" href="$scripturl?board=$curboard"><b>$curboardname</b></a></font>
        <br><font size="1">$curboarddescr<BR>
        <i>$showmods</i></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$threadcount{$curboard}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$messagecount{$curboard}</font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle" width="24%"><font size="1">$lastposttime{$curboard}<BR>$txt{'525'} $lastposter</font></td>
      </tr>~;
		}
	}
	my $checkadded = 0;
	$guests = 0;
	$users = '';
	$numusers = 0;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			if(!$yyUDLoaded{$musername}) { &LoadUser($name); }
			if(exists $userprofile{$name}) {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size="1">,</font> \n~;
			}
			else { $guests++; }
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;
	if($username ne 'Guest') {
		$ims = @immessages;
		### LIMITED IM MOD ###
if($userimcfg[5] eq "on") {
$yymain .= qq~<script language="javascript"> function viewinstant() { window.open("$scripturl?action=im") } </script>~; }
else {
$yymain .= qq~<script language="javascript"> function viewinstant() { location.href = ("$scripturl?action=im") } </script>~; }

if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $minnum $imtxt{'12'} $txt{'316'}!\\n$numibox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IM; 
}

if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $moutnum $imtxt{'12'} $txt{'320'}!\\n$numobox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IMOUT; 
}

if ($storenum > $numstore && $numstore ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $storenum $imtxt{'12'} $imtxt{'46'}!\\n$numstore $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_STORE; 
}

$ims = qq~<BR>$txt{'796'} <a href="$scripturl?action=im"><B>$ims</B></a> $imtxt{'24'}: <a href="$scripturl?action=im"><B>$imnewcount</B></a>~;

### END LIMITED IM ###

		$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="6" align="center">
        <table cellpadding="0" border="0" cellspacing="0" width="100%">
          <tr>
            <td align="left"> <font size="1">
            <img src="$imagesdir/on.gif" border=0 alt="$txt{'333'}"> $txt{'333'}&nbsp;&nbsp;
            <img src="$imagesdir/off.gif" border=0 alt="$txt{'334'}"> $txt{'334'}</font></td>
            <td align="right"><font size=1>&nbsp;
~;
	if($showmarkread) { $yymain .= qq~<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~; }
	$yymain .= qq~
            </font></td>
          </tr>
        </table>
        </td>
      </tr>~;
	}
	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>

<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td>
      </tr>~;
	$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'200'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/info.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top" align="center"><font size="1">
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left" width="60%"><font size="1">
            $txt{'490'} <B>$totalt</B> &nbsp; - &nbsp; $txt{'489'} <B>$totalm</B>
	    ~;
	if($Show_RecentBar) {
		require "$sourcedir/Recent.pl";
		&LastPost;
	}
	$yymain .= qq~
	    </font></td>
	    <td valign="top" align="left" width="40%"><font size="1">
	    $txt{'488'} <a href="$scripturl?action=mlall"><B>$memcount</B></a>
	    ~;
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$yymain .= qq~<BR>$txt{'201'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;
	}
	$yymain .= qq~
	    $ims
	    </font></td>
	  </tr>
	</table>
	</font></td>
      </tr><tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'158'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">
            $guests $txt{'141'}, $numusers $txt{'142'}<BR>$users<br>$uttxt{'1'} $usertodaycount $uttxt{'2'} $usertoday
            </font></td>
          </tr>
        </table>
        </font></td>

~;
	$total_posts = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
			@thiscurcat = <FILE>;
			chomp @thiscurcat;
		fclose(FILE);
		foreach $curboard (@thiscurcat) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);
			$total_posts += $messagecount;
		}
	}

	my(@templist, @SortAList);
	fopen(FILE, "$memberdir/memberlist.txt");
	@membername = <FILE>;
	$memcount = @membername;
	fclose(FILE);
	$z = 0;
	$total_topposts = 0;
	for($i=0;$i<$memcount;$i++) {
		chomp(@membername);
		$membname = $membername[$i];
		fopen(MEMBERFILE,"$memberdir/$membname.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		chomp(@member);
		if($member[6] > 0) {
			$templist[$z] .= qq($member[6]|$member[1]|$membname);
			$z++;
		}
	}
	@SortAList = sort{$b<=>$a} (@templist);
	$pstmem = @SortAList;
	if($pstmem > $high_lst) { $pstmem = $high_lst }

	if($pstmem > 0) {
		$yymain .= qq~
	      </tr><tr>
	        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'411'} $pstmem $txt{'306'}</b></font></td>
	      </tr><tr>
	        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/guest.gif" border="0" alt=""></td>
	        <td class="windowbg2" bgcolor="$color{'windowbg2'}">
	        <table width="98%" cellpadding="3" align="center">
      	  <tr>
	        <td width="50%" valign="top" align="left">
	        <table cellpadding="2" cellspacing="0" border="0" align="left">
		~;
		for($i=0;$i<$pstmem;$i++) {
			$x = $i+1;
			chomp(@SortAList);
			($shposts[$i], $shname[$i], $usname[$i]) = split(/\|/, $SortAList[$i]);
			$total_topposts = $total_topposts + $shposts[$i];
			$Bar = "";
			$barchart = ($shposts[$i]);
			$bartemp = ($shposts[$i] * 100);
			$barwidth = ($bartemp / $shposts[0]);
			$barwidth = ($barwidth + 0.5);
			$barwidth = int($barwidth);
			if($barwidth > 100) {$barwidth = 100}
			if ($barwidth < 1) {$Bar = "$Bar";}
			else {
				$Bar = qq~<img src="$imagesdir/bar.gif" width="$barwidth" height="10" alt="" border="0">~;
			}
			if ($Bar eq "") { $Bar="&nbsp;"; }
			&LoadUser($usname[$i]);
		$yymain .= qq~
	          <tr>
	            <td valign="middle" align="right"><font size="1"><b>$x.</b></font></td>
	            <td valign="middle" align="left"><font size="1"><a href="$scripturl?action=viewprofile;username=$useraccount{$usname[$i]}"><b>$shname[$i]</b></a></font></td>
	            <td valign="middle" align="right"><font size="1">$shposts[$i]</font></td>
			<td valign="middle" align="left">$Bar</td>
	          </tr>
		~;
		}
		if ($total_posts > 0) { $tmp_pct = ($total_topposts * 100) / $total_posts; } else { $tmp_pct = 0; }
		$top_pct = sprintf ("%.2f", $tmp_pct);
		$yymain .= qq~
	        </table>
	        </td>
	        <td width="50%" valign="top" align="left"><font size="1">
			$pstmem $txt{'314'}:<br>
			- $total_topposts $txt{'86'}<br>
			- $top_pct% $txt{'309'} $txt{'190'} $txt{'86'}
	        </font></td>
		</tr>
		</table>
		</td>
		~;
	}
	$yymain .= qq~


      </tr>~;
########### Newcalendar mod start #######################
	chomp $newcalgroup;
	@newcalgrouplist = split(",",$newcalgroup);
	$newcalgroupflag = 0;
	foreach $newcalgroupitem (@newcalgrouplist) {
		if ($settings[7] eq $newcalgroupitem) { $newcalgroupflag = 1; }
	}
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $newcalgroupflag ==1 ) {
	if ($newcalmoon2 == 1) {
		require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;

		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$moonpict = qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$moonpict = qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$moonpict = qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	} else {
		$moonpict = qq~<img src="$imagesdir/newcal.gif" alt="" border="0">~;
	}
	$yymain .=qq~
       <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$ecaltxt{'55'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><a href="$cgi;action=newcalendar">$moonpict</a></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
require "$sourcedir/NewcalIndex.pl";
if ($newcalindexmini == 1) {
	$yymain .=qq~
<table width='100%'>
  <tr>
    <td valign='top'>
      <font size="1">~;
        &IndexCal;
	$yymain .=qq~
      </font>
    </td><td align='right'>~;
	require "$sourcedir/NewcalPost.pl";
      &MiniCalYY;
      $yymain .=qq~$yyminical~;
	$yymain .=qq~
    <td>
  </tr>
</table>~;
} else {
	&IndexCal;
}
$yymain .=qq~  
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########### Newcalendar mod end #######################
########chat insertion###########
	require "$vardir/ChatSettings.txt";
	chomp $chatgroup;
	@chatgrouplist = split(",",$chatgroup);
	$chatgroupflag = 0;
	foreach $chatgroupitem (@chatgrouplist) {
		if ($settings[7] eq $chatgroupitem) { $chatgroupflag = 1; }
	}
	if ($chatopen == 1 || $settings[7] eq 'Administrator' || $chatgroupflag == 1 ) {
		$yymain .=qq~
      <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$chadmtxt{'7'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
		$cguests = 0;
		$cusers = '';
		open(OF,"$vardir/online.txt") or dienice ("Can't open file: $!");
		@ary = <OF>;
		close(OF);
		foreach $line (@ary) {
			chomp($line);
			($of,$name,$ip,$displayname,$level,$time,$non7,$non8,$non9,$non10,$non11) = split(//,$line);
        		if( $name ) {
				if( exists $userprofile{$name} ) {
					$cusers .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">\n$displayname</a><font size=1>,</font>\n~;
				} else {
					++$cguests;
				}
			}
		}
		$yymain .=qq~
			$cusers<br>
		~;

		$windowname=$mbname;
		$windowname=~ s/ //g;
		$windowname=~ s/\W//g;

		if ($password eq ""){
			if ($enable_guestposting == 0){
				$yymain .=qq~<font size=2>$chadmtxt{'8'}</font>~;
			} else {
				$yymain .=qq~$chadmtxt{'9'}$cguests<br>\n<br><a href=javascript\:OpenAdsDetail(\'$cgi&action=chatnow\&job=login\',\"$windowname\")>$chadmtxt{'10'}</a>~;
			}
		} elsif ($password ne "") {
			if ($enable_guestposting == 1){
				$yymain .=qq~$chadmtxt{'9'}$cguests<br>~;
			}
			$yymain .=qq~<br><a href=javascript\:OpenAdsDetail(\'$cgi\&action=chatnow\&job=login',\"$windowname\")>$chadmtxt{'10'}</a>~;
		}
		$yymain .=qq~
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
	}
########chat ended############

	if($username eq 'Guest') {
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_title="$txt{'34'} <small><a href=\"$cgi;action=reminder\">($txt{'315'})</a></small>";
		&sharedLogin;
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;

if($imnewcount > 0 && $enable_mailpopup == 1) {
		if($imnewcount > 1) { $en = "s"; $en2 = "$imtxt{'47'}"; } else { $en = ""; $en2 = "$imtxt{'48'}"; }

		open(FILE, "$memberdir/$username.imconfig");
		@imuserdata = <FILE>;
		close(FILE);

		chomp($imuserdata[3]);
		chomp($imuserdata[5]);

		if($imuserdata[3] eq "on") {
	if($imuserdata[5] eq "on") {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	} else {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	}
		$yymain .= qq~
	<script language="JavaScript">
	<!-- BEGIN
		if (confirm("$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?")) { rimpu(); } else cancel()
	// END --> 
	</script>
		~;
		}
	}
	$yytitle = "$txt{'18'}";
	&template;
	exit;
}

sub MarkAllRead {
	fopen(FILE, "$vardir/cat.txt");
	my @categories = <FILE>;
	fclose(FILE);
	my( $curcat, $curcatname, $curcataccess, @catboards, @membergroups, $openmemgr, $curboard );
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		chomp $curcatname;
		chomp $curcataccess;
		@catboards = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $curcataccess );
		$openmemgr = 0;
		foreach (@membergroups) {
			if( $_ eq $settings[7]) { $openmemgr = 1; last; }
		}
		if(!$curcataccess || $settings[7] eq 'Administrator') { $openmemgr = 1; }
		unless( $openmemgr ) { next; }
		foreach $curboard (@catboards) {
			chomp $curboard;
			&modlog("$curboard--mark");
			&modlog($curboard);
		}
	}
	&dumplog;
	&BoardIndex;
}

1;